package me.earth.havoxrestart;

import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;
import java.util.StringTokenizer;
import java.util.concurrent.TimeUnit;

public class Main {
    private static Process _process;

    public static void main(String[] args)
        throws IOException, InterruptedException {
        try {
            run();
        } finally {
            Process process = _process;
            if (process != null && process.isAlive()) {
                System.err.println("Quit unexpectedly, killing Process...");
                process.destroy();
            }
        }
    }

    private static void run() throws IOException, InterruptedException {
        System.out.println("Welcome to HavoxRestart!");
        System.out.println("This jar is both an 3arthh4ck plugin and a normal application.");
        System.out.println("So make sure to place it in your earthhack/plugins folder!");
        System.out.println("Please type in the command to launch HeadlessMc.");
        System.out.println("HavoxRestart will pipe your inputs to the process you started like this.");
        System.out.println("Every few hours the 3arthh4ck plugin will shutdown the game.");
        System.out.println("When that happens your initial command will get repeated.");
        System.out.println("Start the game with the havox.delay SystemProperty to configure the restart interval in seconds.");

        Scanner scanner = new Scanner(System.in);
        String command = scanner.nextLine();
        StringTokenizer st = new StringTokenizer(command);
        String[] commands = new String[st.countTokens()];
        for (int i = 0; st.hasMoreTokens(); i++) {
            commands[i] = st.nextToken();
        }

        if (commands.length == 0) {
            throw new IllegalArgumentException("The command you entered was empty!");
        }

        //noinspection InfiniteLoopStatement
        while (true) {
            System.out.println("Running process for args: " + Arrays.toString(commands));
            Process process = new ProcessBuilder().command(commands).inheritIO().start();
            _process = process;
            System.out.println("Waiting for process to exit...");
            process.waitFor();
            System.out.println("Process has stopped, you may kill HavoxRestart safely in the next 20 seconds...");
            //noinspection BusyWait
            Thread.sleep(TimeUnit.SECONDS.toMillis(20));
        }
    }

}
